Merge branch 'salvatoret/android-dev-2023-11' into 'main'

Update the Android development enviornment setup

See merge request veilid/veilid!237
This commit is contained in:
Christien Rioux 2023-11-23 14:51:38 +00:00
commit bd74ac7bce
8 changed files with 69 additions and 81 deletions

1
.gitignore vendored
View File

@ -234,6 +234,7 @@ cython_debug/
veilid-python/demo/.demokeys
.vscode/
.idea/
## Ignore emacs backup files
~*

View File

@ -63,13 +63,12 @@ sdkmanager --install "cmake;3.22.1"
```
Export environment variables and add the Android SDK platform-tools directory to
your path.
your path. See [instructions here](https://developer.android.com/tools/variables).
```shell
cat << EOF >> ~/.profile
export ANDROID_SDK_ROOT=<path to sdk>
export ANDROID_NDK_HOME=$ANDROID_SDK_ROOT/ndk/25.1.8937393
export PATH=\$PATH:$ANDROID_SDK_ROOT/platform-tools
export ANDROID_HOME=<path to sdk>
export PATH=$PATH:$ANDROID_HOME/tools:$ANDROID_HOME/tools/bin:$ANDROID_HOME/platform-tools
EOF
```
@ -119,13 +118,12 @@ to maintain your Android dependencies. Use the SDK Manager in the IDE to install
#### Setup command line environment
Export environment variables and add the Android SDK platform-tools directory to
your path.
your path. See [instructions here](https://developer.android.com/tools/variables).
```shell
cat << EOF >> ~/.zshenv
export ANDROID_SDK_ROOT=$HOME/Library/Android/sdk
export ANDROID_NDK_HOME=$HOME/Library/Android/sdk/ndk/25.1.8937393
export PATH=\$PATH:$HOME/Library/Android/sdk/platform-tools
export ANDROID_HOME=$HOME/Library/Android/sdk
export PATH=$PATH:$ANDROID_HOME/tools:$ANDROID_HOME/tools/bin:$ANDROID_HOME/platform-tools
EOF
```

View File

@ -9,20 +9,20 @@ fi
if [ ! -z "$(command -v apt)" ]; then
# Install APT dependencies
sudo apt update -y
sudo apt install -y openjdk-11-jdk-headless iproute2 curl build-essential cmake libssl-dev openssl file git pkg-config libdbus-1-dev libdbus-glib-1-dev libgirepository1.0-dev libcairo2-dev checkinstall unzip llvm wabt python3-pip
sudo apt install -y openjdk-17-jdk-headless iproute2 curl build-essential cmake libssl-dev openssl file git pkg-config libdbus-1-dev libdbus-glib-1-dev libgirepository1.0-dev libcairo2-dev checkinstall unzip llvm wabt python3-pip
elif [ ! -z "$(command -v dnf)" ]; then
# DNF (formerly yum)
sudo dnf update -y
# libgirepository -> gobject-introspection
# iproute2 -> iproute
# openjdk-11-jdk-headless -> java-11-openjdk-headless
# openjdk-17-jdk-headless -> java-11-openjdk-headless
# checkinstall does not appear to be a thing in Fedora 38 repos
#
# Seems like iproute and file might come preinstalled but I put
# them in anyway
#
# Also Fedora doesn't come with pip
sudo dnf install -y java-11-openjdk-headless iproute curl cmake openssl-devel openssl git file pkg-config dbus-devel dbus-glib gobject-introspection-devel cairo-devel unzip llvm wabt python3-pip gcc-c++
sudo dnf install -y java-17-openjdk-headless iproute curl cmake openssl-devel openssl git file pkg-config dbus-devel dbus-glib gobject-introspection-devel cairo-devel unzip llvm wabt python3-pip gcc-c++
# build-essentials
sudo dnf groupinstall -y 'Development Tools'
fi
@ -50,8 +50,7 @@ rm -rf $HOME/Android/cmdline-tools $HOME/Android/cmdline-tools.zip
cat >> $HOME/.profile <<END
source "\$HOME/.cargo/env"
export PATH=\$PATH:\$HOME/Android/Sdk/ndk/25.1.8937393/toolchains/llvm/prebuilt/linux-x86_64/bin:\$HOME/Android/Sdk/platform-tools:\$HOME/Android/Sdk/cmdline-tools/latest/bin
export ANDROID_NDK_HOME=\$HOME/Android/Sdk/ndk/25.1.8937393
export ANDROID_SDK_ROOT=\$HOME/Android/Sdk
export ANDROID_HOME=\$HOME/Android/Sdk
END
break ;;
[nN] ) echo Skipping Android SDK;

View File

@ -24,31 +24,24 @@ while true; do
case $response in
[yY] ) echo Checking android setup...;
# ensure ANDROID_SDK_ROOT is defined and exists
if [ -d "$ANDROID_SDK_ROOT" ]; then
echo '[X] $ANDROID_SDK_ROOT is defined and exists'
# ensure ANDROID_HOME is defined and exists
if [ -d "$ANDROID_HOME" ]; then
echo '[X] $ANDROID_HOME is defined and exists'
else
echo '$ANDROID_SDK_ROOT is not defined or does not exist'
echo '$ANDROID_HOME is not defined or does not exist'
exit 1
fi
# ensure Android Command Line Tools exist
if [ -d "$ANDROID_SDK_ROOT/cmdline-tools/latest/bin" ]; then
if [ -d "$ANDROID_HOME/cmdline-tools/latest/bin" ]; then
echo '[X] Android command line tools are installed'
else
echo 'Android command line tools are not installed'
exit 1
fi
# ensure ANDROID_NDK_HOME is defined and exists
if [ -d "$ANDROID_NDK_HOME" ]; then
echo '[X] $ANDROID_NDK_HOME is defined and exists'
else
echo '$ANDROID_NDK_HOME is not defined or does not exist'
exit 1
fi
# ensure ndk is installed
ANDROID_NDK_HOME="$ANDROID_HOME/ndk/25.1.8937393"
if [ -f "$ANDROID_NDK_HOME/ndk-build" ]; then
echo '[X] Android NDK is installed at the location $ANDROID_NDK_HOME'
else
@ -57,7 +50,7 @@ while true; do
fi
# ensure cmake is installed
if [ -d "$ANDROID_SDK_ROOT/cmake" ]; then
if [ -d "$ANDROID_HOME/cmake" ]; then
echo '[X] Android SDK CMake is installed'
else
echo 'Android SDK CMake is not installed'
@ -65,7 +58,7 @@ while true; do
fi
# ensure emulator is installed
if [ -d "$ANDROID_SDK_ROOT/emulator" ]; then
if [ -d "$ANDROID_HOME/emulator" ]; then
echo '[X] Android SDK emulator is installed'
else
echo 'Android SDK emulator is not installed'

View File

@ -13,16 +13,16 @@ while true; do
read -p "Did you install Android SDK? Y/N " response
case $response in
[yY] ) echo Checking android setup...;
# ensure ANDROID_SDK_ROOT is defined and exists
if [ -d "$ANDROID_SDK_ROOT" ]; then
echo '[X] $ANDROID_SDK_ROOT is defined and exists'
# ensure ANDROID_HOME is defined and exists
if [ -d "$ANDROID_HOME" ]; then
echo '[X] $ANDROID_HOME is defined and exists'
else
echo '$ANDROID_SDK_ROOT is not defined or does not exist'
echo '$ANDROID_HOME is not defined or does not exist'
exit 1
fi
# ensure Android Command Line Tools exist
if [ -d "$ANDROID_SDK_ROOT/cmdline-tools/latest/bin" ]; then
if [ -d "$ANDROID_HOME/cmdline-tools/latest/bin" ]; then
echo '[X] Android command line tools are installed'
else
echo 'Android command line tools are not installed'
@ -30,13 +30,14 @@ while true; do
fi
# ensure Android SDK packages are installed
$ANDROID_SDK_ROOT/cmdline-tools/latest/bin/sdkmanager build-tools\;33.0.1 ndk\;25.1.8937393 cmake\;3.22.1 platform-tools platforms\;android-33
$ANDROID_HOME/cmdline-tools/latest/bin/sdkmanager build-tools\;33.0.1 ndk\;25.1.8937393 cmake\;3.22.1 platform-tools platforms\;android-33
# ensure ANDROID_NDK_HOME is defined and exists
ANDROID_NDK_HOME="$ANDROID_HOME/ndk/25.1.8937393"
if [ -d "$ANDROID_NDK_HOME" ]; then
echo '[X] $ANDROID_NDK_HOME is defined and exists'
echo '[X] Android NDK is defined and exists'
else
echo '$ANDROID_NDK_HOME is not defined or does not exist'
echo 'Android NDK is not defined or does not exist'
exit 1
fi
@ -49,7 +50,7 @@ while true; do
fi
# ensure cmake is installed
if [ -d "$ANDROID_SDK_ROOT/cmake" ]; then
if [ -d "$ANDROID_HOME/cmake" ]; then
echo '[X] Android SDK CMake is installed'
else
echo 'Android SDK CMake is not installed'
@ -57,7 +58,7 @@ while true; do
fi
# ensure emulator is installed
if [ -d "$ANDROID_SDK_ROOT/emulator" ]; then
if [ -d "$ANDROID_HOME/emulator" ]; then
echo '[X] Android SDK emulator is installed'
else
echo 'Android SDK emulator is not installed'
@ -119,26 +120,31 @@ else
exit 1
fi
# ensure Java 17 is the active version
JAVA_VERSION=$(java -version 2>&1 | head -n 1 | cut -d\" -f2)
if [ "$JAVA_VERSION" == "17" ]; then
echo '[X] Java 17 is available in the path'
else
echo 'Java 17 is not available in the path'
exit 1
fi
# ensure we have command line tools
xcode-select --install 2> /dev/null || true
until [ -d /Library/Developer/CommandLineTools/usr/bin ]; do
sleep 5;
done
# ensure packages are installed
if [ "$BREW_USER" == "" ]; then
if [ -d /opt/homebrew ]; then
BREW_USER=`ls -lad /opt/homebrew/. | cut -d\ -f4`
echo "Must sudo to homebrew user \"$BREW_USER\" to install capnp package:"
elif [ -d /usr/local/Homebrew ]; then
BREW_USER=`ls -lad /usr/local/Homebrew/. | cut -d\ -f4`
echo "Must sudo to homebrew user \"$BREW_USER\" to install capnp package:"
# install packages
# if $BREW_USER is set, run brew as that user, otherwise run it regularly
# this allows for developers who have brew installed as a different user to run this script
if [ -z "$BREW_USER" ]; then
BREW_COMMAND="brew"
else
echo "Homebrew is not installed in the normal place. Trying as current user"
BREW_USER=`whoami`
BREW_COMMAND="sudo -H -u $BREW_USER brew"
fi
fi
sudo -H -u $BREW_USER brew install capnp cmake wabt llvm openjdk@17 jq
$BREW_COMMAND install capnp cmake wabt llvm jq
# install targets
rustup target add aarch64-apple-darwin aarch64-apple-ios aarch64-apple-ios-sim x86_64-apple-darwin x86_64-apple-ios wasm32-unknown-unknown aarch64-linux-android armv7-linux-androideabi i686-linux-android x86_64-linux-android
@ -149,5 +155,9 @@ cargo install wasm-bindgen-cli wasm-pack cargo-edit
# install pip packages
pip3 install --upgrade bumpversion
echo Installing cocoapods. This may take a while.
sudo gem install cocoapods
if command -v pod &> /dev/null; then
echo '[X] CocoaPods is available in the path'
else
echo 'CocoaPods is not available in the path, installing it now'
$BREW_COMMAND install cocoapods
fi

View File

@ -14,17 +14,17 @@ AVD_TAG="google_atd"
AVD_IMAGE="system-images;android-30;$AVD_TAG;$ANDROID_ABI"
AVD_DEVICE="Nexus 10"
SDKMANAGER=$ANDROID_SDK_ROOT/tools/bin/sdkmanager
AVDMANAGER=$ANDROID_SDK_ROOT/tools/bin/avdmanager
SDKMANAGER=$ANDROID_HOME/tools/bin/sdkmanager
AVDMANAGER=$ANDROID_HOME/tools/bin/avdmanager
if ! command -v $SDKMANAGER; then
SDKMANAGER=$ANDROID_SDK_ROOT/cmdline-tools/latest/bin/sdkmanager
AVDMANAGER=$ANDROID_SDK_ROOT/cmdline-tools/latest/bin/avdmanager
SDKMANAGER=$ANDROID_HOME/cmdline-tools/latest/bin/sdkmanager
AVDMANAGER=$ANDROID_HOME/cmdline-tools/latest/bin/avdmanager
if ! command -v $SDKMANAGER; then
echo "Can't find 'sdkmanager' in the usual places."
exit
fi
fi
EMULATOR=$ANDROID_SDK_ROOT/emulator/emulator
EMULATOR=$ANDROID_HOME/emulator/emulator
if ! command -v $EMULATOR; then
echo "Can't find 'emulator' in the usual places."
exit
@ -35,7 +35,7 @@ $SDKMANAGER --install "$AVD_IMAGE"
# Make AVD
echo "no" | $AVDMANAGER --verbose create avd --force --name "$AVD_NAME" --package "$AVD_IMAGE" --tag "$AVD_TAG" --abi "$ANDROID_ABI" --device "$AVD_DEVICE"
# Run emulator
$ANDROID_SDK_ROOT/emulator/emulator -avd testavd -no-snapshot -no-boot-anim -no-window &
$ANDROID_HOME/emulator/emulator -avd testavd -no-snapshot -no-boot-anim -no-window &
( trap exit SIGINT ; read -r -d '' _ </dev/tty ) ## wait for Ctrl-C
kill %1
wait

View File

@ -96,8 +96,8 @@ fn fix_android_emulator() {
let target_arch = env::var("CARGO_CFG_TARGET_ARCH").unwrap();
if target_arch == "x86_64" && target_os == "android" {
let missing_library = "clang_rt.builtins-x86_64-android";
let android_ndk_home = env::var("ANDROID_NDK_HOME").expect("ANDROID_NDK_HOME not set");
let lib_path = glob(&format!("{android_ndk_home}/**/lib{missing_library}.a"))
let android_home = env::var("ANDROID_HOME").expect("ANDROID_HOME not set");
let lib_path = glob(&format!("{android_home}/ndk/25.1.8937393/**/lib{missing_library}.a"))
.expect("failed to glob")
.next()
.expect("Need libclang_rt.builtins-x86_64-android.a")

View File

@ -59,26 +59,13 @@ if [ "$OS" == "linux" ]; then
flutter config --enable-linux-desktop --enable-android
elif [ "$OS" == "macos" ]; then
# # ensure x86_64 homebrew is installed
# if [ -f /usr/local/bin/brew ] &> /dev/null; then
# echo '[X] x86_64 homebrew is available'
# else
# echo 'x86_64 homebrew is not available, run this:'
# echo 'arch -x86_64 zsh'
# echo '/bin/bash -c "$(curl -fsSL https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh)"'
# exit 1
# fi
# ensure packages are installed
# if [ "$BREW_USER" == "" ]; then
# BREW_USER=`ls -lad /usr/local/bin/. | cut -d\ -f4`
# echo "Must sudo to homebrew user \"$BREW_USER\" to install LLVM package:"
# fi
# sudo -H -u $BREW_USER arch -x86_64 /usr/local/bin/brew install llvm
echo "Must sudo to root to install CocoaPods gem:"
# sudo arch -x86_64 gem install ffi
sudo arch -x86_64 gem install cocoapods
# check if cocoapods is installed, if its not, install it
if command -v pod &> /dev/null; then
echo '[X] CocoaPods is available in the path'
else
echo 'CocoaPods is not available in the path, installing it now'
brew install cocoapods
fi
if [ "$(uname -p)" == "arm" ]; then
sudo softwareupdate --install-rosetta --agree-to-license